package com.expd.apm.extension.agent.inputargs;

import com.expd.apm.extension.agent.metricpublisher.AgentMetricPublisher;
import com.expd.apm.extension.agent.metricpublisher.MetricPublisherFactory;
import com.wily.introscope.agent.IAgent;
import com.wily.introscope.agent.stat.DataAccumulatorFactory;
import com.wily.util.feedback.Module;
import com.wily.util.heartbeat.ITimestampedRunnable;

public class InputArgs implements ITimestampedRunnable {
	private InputArgsCollector collector = null;
	private Module kInputArgs = new Module("InputArgs");
	
	private IAgent fAgent;

	public InputArgs(IAgent agent) {
		fAgent = agent;
		fAgent.IAgent_getModuleFeedback().debug(this.kInputArgs, "Initializing Collector");
		
	    this.collector = new InputArgsCollector(":Java Options", fAgent);

		if (this.collector != null) {
			fAgent.IAgent_getModuleFeedback().debug(this.kInputArgs, "Collector initialized and publishing");
			this.collector.publishMetricValues();
		} else {
			fAgent.IAgent_getModuleFeedback().debug(this.kInputArgs, "Could not initialize Collector");
		}
	}

	public void ITimestampedRunnable_execute(long arg0) { 
		if (this.collector != null) {
			this.collector.publishMetricValues();
		}
	}

	public void turnOffAllMetrics() throws Exception {
		if (this.collector != null) {
			try {
				final DataAccumulatorFactory accumulatorFactory = ((AgentMetricPublisher)MetricPublisherFactory.getInstance().getMetricPublisher()).getAccumulatorFactory();
				this.collector.turnOffMetrics(accumulatorFactory);
			} catch (Exception e) {
				this.fAgent.IAgent_getModuleFeedback().error(kInputArgs, "Unable to turn off InputArgs metrics reporting", e);
				throw new Exception(e);
			}
		}
	}

	public InputArgsCollector getCollector() {
		return this.collector;
	}
}
