package com.expd.apm.extension.agent.metricpublisher;

import java.util.Map;

/**
 * The MetricPublisher Interface, used to output metrics to Introscope. 
 *
 * @author Jack Butler (jack.butler@expeditors.com)
 * @version 1.0 2013-02-11
 */
public interface IMetricPublisher {
	  public abstract Map<String, Long> getMetrics();
	  public abstract void publish(String metricName, int value);
	  public abstract void publish(String metricName, int value, boolean isPercentage);
	  public abstract void publish(String metricName, long value);
	  public abstract void publish(String metricName, String value);
	  public abstract void removeMetric(String metricName);
	  public abstract void removeMetrics();
}

