package com.expd.apm.extension.agent.metricpublisher;

import java.util.Map;

/**
 * The Class SystemOutMetricPublisher; optionally used to print to system out instead of to the workstation. 
 *
 * @author Jack Butler (jack.butler@expeditors.com)
 * @version 1.0 2013-02-11
 */
public class SystemOutMetricPublisher implements IMetricPublisher {
	
	/* (non-Javadoc)
	 * @see com.expd.apm.extension.jtop.metricpublisher.IMetricPublisher#publish(java.lang.String, long)
	 */
	public void publish(String metricName, long value) {
		System.out.println(metricName + '=' + value);
	}

	/**
	 * Publish.
	 *
	 * @param metricName the metric name under which the value is published
	 * @param value the value to publish
	 */
	public void publish(String metricName, String value) {
		System.out.println(metricName + '=' + value);
	}

	/* (non-Javadoc)
	 * @see com.expd.apm.extension.jtop.metricpublisher.IMetricPublisher#publish(java.lang.String, int)
	 */
	public void publish(String metricName, int value) {
		System.out.println(metricName + '=' + value);
	}
	
	public void publish(String metricName, int value, boolean isPercentage) {
		publish(metricName, value);
	}
	
	public void removeMetric(String metricName) {
		
	}

	public void removeMetrics() {
		
	}

	public Map<String, Long> getMetrics() {
		return null;
	}
}
